<?php
if (!class_exists('Mfp_12_dokan_need')) {
  class  Mfp_12_dokan_need
  {

    private static $rootPluginFolder;

    public function __construct()
    {
      add_action('init', array($this, 'mf_load_text_domain'));

      add_action('admin_enqueue_scripts', array($this, 'change_font'), PHP_INT_MAX/*1*/); //for admin
      add_action('get_footer', array($this, 'change_font'), PHP_INT_MAX /*1*/);
      add_action('wp_enqueue_scripts', array($this, 'change_font'), PHP_INT_MAX/*1*/); //for front


      add_action('wp_enqueue_scripts', array($this, 'mf_rtl'), PHP_INT_MAX); //for front
      add_action('admin_enqueue_scripts', array($this, 'mf_rtl'), PHP_INT_MAX); //for admin


      add_action('wp_loaded', array($this, 'mf_load_rtl_style'), PHP_INT_MAX);
      add_action('get_footer', array($this, 'mf_load_rtl_style'), PHP_INT_MAX);
      add_action('admin_enqueue_scripts', array($this, 'mf_load_rtl_style'), PHP_INT_MAX); //for admin
      //add_action( 'wp_enqueue_scripts', array($this,'mf_load_rtl_style') ,PHP_INT_MAX);



      add_action('init', array($this, 'mfReplaceMfDokanLite'));

      add_filter('site_transient_update_plugins', array($this, 'AS_disable_plugin_updates'));

    }

    public static function AS_disable_plugin_updates($value)
    {
      //create an array of plugins you want to exclude from updates ( string composed by folder/main_file.php)
      $pluginsNotUpdatable = [
        'dokan-lite/dokan.php',
        'dokan-pro/dokan-pro.php',
        //        'woocommerce/woocommerce.php', //for test
      ];

      if (isset($value) && is_object($value)) {
        foreach ($pluginsNotUpdatable as $plugin) {
          if (isset($value->response[$plugin])) {
            unset($value->response[$plugin]);
          }
        }
      }
      return $value;
    }


    public static function mf_load_text_domain()
    {
      self::$rootPluginFolder = dirname(plugin_basename(__FILE__), 3) . '/';

      if (function_exists('load_plugin_textdomain')) {
        load_plugin_textdomain(/*must rename this*/'dokan', false, self::$rootPluginFolder . 'languages/');
      }
    }

    public static function change_font()
    {
      if (is_rtl()) {
        $mfStyle = plugin_dir_url(__FILE__) . 'css/mffont.css';
        wp_enqueue_style('Mfp_12_dokan_font',  $mfStyle);
      }
    }

    public static function mf_rtl()
    {

      if (is_rtl()) {
        //wp_enqueue_style( 'Mfp_12_dokan_style', plugin_dir_url( __FILE__ ) . 'css/mfrtl.css' );
        wp_register_style('Mfp_12_dokan_style', plugin_dir_url(__FILE__) . 'css/mfrtl.css');
      }
    }

    public static function mf_load_rtl_style()
    {
      if (is_rtl()) {
        wp_enqueue_style('Mfp_12_dokan_style');
      }
    }


    public static function check_changed_size_and_replace($source, $dest)
    {
      if (!file_exists($source)) return;

      $dir_dest = dirname($dest);
      if (!file_exists($dir_dest))
        if (!mkdir($dir_dest, 0777, true)) {
          //die('Failed to create directories...');
          return;
        }


      $source_size = 0;
      $source_size = filesize($source);

      $dest_size = 0;
      if (file_exists($dest))
        $dest_size = filesize($dest);

      if ($source_size != $dest_size)
        copy($source, $dest);
    }


    public static function mfReplaceMfDokanLite()
    {
      return;
      $dest_dokan_lite_dir = WP_PLUGIN_DIR . '/dokan-lite/';
      $source_dokan_lite_dir = dirname(__FILE__) . '/dokan-lite/';

      $file = 'assets/js/vue-admin.js';
      self::check_changed_size_and_replace($source_dokan_lite_dir . $file, $dest_dokan_lite_dir . $file);

      $file = 'assets/js/vue-admin.min.js';
      self::check_changed_size_and_replace($source_dokan_lite_dir . $file, $dest_dokan_lite_dir . $file);

      $file = 'assets/js/vue-vendor.js';
      self::check_changed_size_and_replace($source_dokan_lite_dir . $file, $dest_dokan_lite_dir . $file);

      $file = 'assets/js/vue-vendor.min.js';
      self::check_changed_size_and_replace($source_dokan_lite_dir . $file, $dest_dokan_lite_dir . $file);

      /////
      $file = 'templates/settings/header.php';
      self::check_changed_size_and_replace($source_dokan_lite_dir . $file, $dest_dokan_lite_dir . $file);
    }
  } //class
} //if (!class_exists

new Mfp_12_dokan_need();
